
package org.nzdl.service;

import java.util.*;

import org.nzdl.util.NzdlConstants;

public class NzdlQuery extends java.lang.Object {

  /** */
  private Map m_Options = null;

  /** */

  public NzdlQuery() {
    m_Options = new HashMap();
    setQueryTerm   ( NzdlConstants.DEFAULT_QUERY_TERM );
    setQueryType   ( NzdlConstants.DEFAULT_QUERY_TYPE );
    setCaseFolding ( NzdlConstants.DEFAULT_CASE_FOLDING );
    setStemming    ( NzdlConstants.DEFAULT_STEMMING );
    setStartResults( NzdlConstants.DEFAULT_START_RESULTS );
    setEndResults  ( NzdlConstants.DEFAULT_END_RESULTS );
    setMaxDocs     ( NzdlConstants.DEFAULT_MAX_DOCS );
  }

  public NzdlQuery( String _term ) {
    m_Options = new HashMap();
    setQueryTerm   ( _term );
    setQueryType   ( NzdlConstants.DEFAULT_QUERY_TYPE );
    setCaseFolding ( NzdlConstants.DEFAULT_CASE_FOLDING );
    setStemming    ( NzdlConstants.DEFAULT_STEMMING );
    setStartResults( NzdlConstants.DEFAULT_START_RESULTS );
    setEndResults  ( NzdlConstants.DEFAULT_END_RESULTS );
    setMaxDocs     ( NzdlConstants.DEFAULT_MAX_DOCS );
  }

  /** */

  public void setQueryTerm(String _term) {
    m_Options.put("Term", _term);
  }

  public void setQueryType(String _type) {
    m_Options.put("QueryType", _type);
  }

  public void setCaseFolding(String _case) {
    m_Options.put("CaseFold", _case);
  }

  public void setStemming(String _stem) {
    m_Options.put("Stem", _stem);
  }

  public void setStartResults(int _start) {
    m_Options.put("StartResults", new Integer(_start));
  }

  public void setEndResults(int _end) {
    m_Options.put("EndResults", new Integer(_end));
  }

  public void setMaxDocs(int _max) {
    m_Options.put("Maxdocs", new Integer(_max));
  }

  /** */

  public String getQueryType() {
    return (String)m_Options.get("QueryType");
  }

  public String getQueryTerm() {
    return (String)m_Options.get("Term");
  }

  public String getCaseFolding() {
    return (String)m_Options.get("CaseFold");
  }

  public String getStemming() {
    return (String)m_Options.get("Stem");
  }

  public int getStartResults() {
    return ((Integer) m_Options.get("StartResults")).intValue();
  }

  public int getEndResults() {
    return ((Integer) m_Options.get("EndResults")).intValue();
  }

  public int getMaxDocs() {
    return ((Integer) m_Options.get("Maxdocs")).intValue();
  }

  /** */

  public Set queryKeySet() {
    return m_Options.keySet();
  }

  public Collection queryValues() {
    return m_Options.values();
  }

}
